//$Id: ErrStream.java,v 1.2 2004/09/24 08:50:51 suzuki Exp $
// 1998 Dec 25  updated for Momo new version
// 1999 Jan 5
//
// ********************************************************************
// * License and Disclaimer                                           *
// *                                                                  *
// * The  Geant4 software  is  copyright of the Copyright Holders  of *
// * the Geant4 Collaboration.  It is provided  under  the terms  and *
// * conditions of the Geant4 Software License,  included in the file *
// * LICENSE and available at  http://cern.ch/geant4/license .  These *
// * include a list of copyright holders.                             *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.  Please see the license in the file  LICENSE  and URL above *
// * for the full disclaimer and the limitation of liability.         *
// *                                                                  *
// * This  code  implementation is the result of  the  scientific and *
// * technical work of the GEANT4 collaboration.                      *
// * By using,  copying,  modifying or  distributing the software (or *
// * any work based  on the software)  you  agree  to acknowledge its *
// * use  in  resulting  scientific  publications,  and indicate your *
// * acceptance of all terms of the Geant4 Software license.          *
// ********************************************************************
//
//
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.lang.Runtime.*;
import java.io.*;
import javax.swing.text.*;

class ErrStream extends Thread implements ActionListener{
  private MOMOpipe pipe;
  private Frame errFrame;
  private TextArea errArea;
  private Button close;
  public boolean isMaking;

  ErrStream(MOMOpipe pipe){    
      //      isMaking = true;           // 
    this.pipe = pipe;
    errFrame = new Frame("Make messagess");
    errFrame.setLayout(new BorderLayout());
    errFrame.add("Center", errArea = new TextArea());
    errFrame.add("South", close = new Button("close"));
    close.addActionListener(this);
    errFrame.setSize(600,500);
    yield();
  }
  public void run(){
    String sline, eline;
    sline = pipe.readStdLine();
    errArea.append("!!!!!!!!!!!!!!!!!!!!!!!!! Welcome to Momo Makes !!!!!!!!!!!!!!!!!!!!!!!!\n\n");
    errArea.append("========================== Start Making ==========================\n\n");
    while((sline=pipe.readStdLine())!=null){
      errArea.append(sline+"\n");
      if (!errFrame.isVisible()){ 
        errFrame.setVisible(true);
      }
    }
    eline = pipe.readStdLine();
    errArea.append("\n >>>>> End of Standrad output\n\n");
    errArea.append("\n +++++++++++++++++++++++++++++++++++++++++++++++++++\n");
    errArea.append("\n >>>>> Error output, if any\n\n");
    while((eline=pipe.readErrLine())!=null){
      errArea.append(eline+"\n");
      if (!errFrame.isVisible()){
        errFrame.setVisible(true);
      }
    }
    errArea.append("\n >>>>> End of Error output\n\n");
    errArea.append("\n ==========================  That's all folks! ==========================\n");
    //    isMaking = false;
    yield();               // yield the priority to others
  }
  public void actionPerformed(ActionEvent ae){
    errFrame.setVisible(false);
    errArea.setText("");
  }
  void close(){
    isMaking = false;
    errFrame.dispose();
    //    stop();
  }
}


















